C
C
C
C               MAIN PROGRAM FOR PROBLEM "MV1_V1.FOR"
C
C     MV - MIXED VARIABLE TYPES
C
C       SAME AS PROBLEM "UC1_V1.FOR" BUT VARIABLE "XT(1)" ALLOWED TO TAKE
C       VALUES FROM USER DEFINED NARROW STRIPS AROUND THE ROUNDED OFF
C       INTEGER VALUES. SET CONTROL PARAMETER "IMV" TO 0 IN THE MAIN PROGRAM.
C
C     MODIFICATIONS INTRODUCED BY DR. S. N. GHANI.
C
C
      DOUBLE PRECISION C(2),FF(4),H(8),OLDCC(2),XDN(2),XG(2),XMAX(2),
     1XMIN(2),XT(2),XUP(2),XX(1),XXMAX(1),XXMIN(1)
C
      DOUBLE PRECISION ALPHA,BETA,DEL,GAMA,PHI,PHICPX
C
      INTEGER ICON,IJK,IMV,IPRINT,K,KNT,LIMIT,N,NRSTRT,NIC
C
C
      WRITE(9,999)
      WRITE(9,998)
C
C      STARTING POINT FOR OPTIMISATION
      XT(1)=-1.2D0
      XT(2)=1.D0
C
C
C     CONTROL PARAMETERS FOR "EVOP"
      ALPHA=1.3D0
      BETA=.5D0
      GAMA=2.D0
      DEL=1.D-12
      PHI=1.D-10
      PHICPX=1.D-10
      ICON=5
      LIMIT=60000
      KNT=25
      N=2
      NIC=1
      K=4
      IPRINT=2
      NRSTRT=2
      IMV=0
      IJK=1
  100 CALL EVOP(ALPHA,BETA,C,DEL,FF,GAMA,H,ICON,IJK,IMV,IPRINT,K,
     1KNT,LIMIT,N,NRSTRT,NIC,OLDCC,PHI,PHICPX,XDN,XG,XMAX,XMIN,XT,XUP,
     2XX,XXMAX,XXMIN)
      IF (IJK .LT. 9) GOTO 100
  999 FORMAT(5X,'OPTIMIZATION OF TEST PROBLEM: "MV1_V1.FOR"'//)
  998 FORMAT(1X,'SAME AS "UC1_V1.FOR" BUT VARIABLE "XT(1)" ALLOWED',
     1' TO TAKE ONLY'/1X,'NEAR INTEGER VALUES.',//' MODIFICATIONS INT',
     2'RODUCED BY DR. S. N. GHANI.'//)
      END
C
C
C
C              SUBROUTINE FOR FUNCTION VALUE
C
      SUBROUTINE FUNC(F,KOUNT,KUT,N,XT)
C
      INTEGER KOUNT,KUT,N
      DOUBLE PRECISION F
      DOUBLE PRECISION XT(2)
C
      KOUNT=KOUNT+1
      KUT=KUT+1
      F=100.D0*((XT(1)*XT(1)-XT(2))*(XT(1)*XT(1)-XT(2)))
      F=F+(1.D0-XT(1))*(1.D0-XT(1))+1.D0
      RETURN
      END
C
C
C               SUBROUTINE FOR EXPLICIT CONSTRAINTS
C
      SUBROUTINE EXPCON(IFLG,ISKP,KKT,KOUNT,M,N,XMAX,XMIN,XT)
C
      INTEGER IFLG,ISKP,KKT,KOUNT,M,N
      DOUBLE PRECISION STRIP
      DOUBLE PRECISION XMAX(2),XMIN(2),XT(2)
C
      KOUNT=KOUNT+1
      KKT=KKT+1
      XMIN(1)=-1000.001D0
      XMIN(2)=-1000.D0
      XMAX(1)=1000.001D0
      XMAX(2)=1000.D0
      IF (IFLG .EQ. 0) THEN
        STRIP=1.D-4
        CALL DINTG2(ISKP,STRIP,XT(1),XMAX(1),XMIN(1))
      ENDIF
      RETURN
      END
C
C
C               SUBROUTINE FOR IMPLICIT CONSTRAINTS
C
      SUBROUTINE IMPCON(KOUNT,M,N,NIC,XT,XX,XXMAX,XXMIN)
C
      INTEGER KOUNT,M,N,NIC
      DOUBLE PRECISION XX(1),XXMAX(1),XXMIN(1),XT(2)
C
      KOUNT=KOUNT+1
      M=M+1
      XX(1)=XT(1)+XT(2)
      XXMAX(1)=1.D5
      XXMIN(1)=-1.D5
      RETURN
      END
