C
C
C              MAIN PROGRAMME FOR PROBLEM "RECTIFIER_FILTER.FOR"
C
C  UC - UNCONSTRAINED
C
C  GHANI, S. N.: OPTIMIZATION OF THE DESIGH OF AN AC TO DC POWER 
C                SUPPLY RECTIFIER FILTER FOR MINIMUM COST
C 
C
      DOUBLE PRECISION C(2),FF(4),H(8),XDN(2),XG(2),XMAX(2),XMIN(2),
     1XT(2),XUP(2),XX(1),XXMAX(1),XXMIN(1),OLDCC(2)
C
      DOUBLE PRECISION ALPHA,BETA,DEL,GAMA,PHI,PHICPX
C
      INTEGER ICON,IJK,IMV,IPRINT,K,KNT,LIMIT,N,NRSTRT,NIC 
	WRITE(9,999)
      WRITE(9,998)
C
C      STARTING POINT FOR OPTIMISATION
C
      XT(1) = 1.0D0
      XT(2) = -1.0D0
C
C     CONTROL PARAMETERS FOR "EVOP"
      ALPHA=1.2D0
      BETA=0.5D0
      GAMA=2.0D0
      DEL=1.0D-12
      PHI=1.0D-10
      PHICPX=1.0D-11
      ICON=5
      LIMIT=6000
      KNT=25
      N=2
      NIC=1
      K=4
      IPRINT=2
      NRSTRT=10
      IMV=0
      IJK=1
  100 CALL EVOP(ALPHA,BETA,C,DEL,FF,GAMA,H,ICON,IJK,IMV,IPRINT,K,
     1KNT,LIMIT,N,NRSTRT,NIC,OLDCC,PHI,PHICPX,XDN,XG,XMAX,XMIN,XT,XUP,
     2XX,XXMAX,XXMIN)
      IF (IJK .LT. 9) GOTO 100
  999 FORMAT(5X,'OPTIMIZATION OF TEST PROBLEM: "RECTIFIER_FILTER_V1.FOR"
     1'//)
  998 FORMAT(1X,'PROBLEM DEVELOPED BY S. N. GHANI:'//)
      CONTINUE
      END
C
C           SUBROUTINE FOR FUNCTION VALUE
      SUBROUTINE FUNC(F,KOUNT,KUT,N,XT)
C
      INTEGER KOUNT,KUT,N
      DOUBLE PRECISION F, T1, T2
      DOUBLE PRECISION XT(2)
C

C     N=N
C            ABOVE TO STOP THE COMPILER FROM COMPLAINING
C
      KOUNT=KOUNT+1
      KUT=KUT+1

C
      T1 = XT(1) * XT(1) + XT(2) * XT(2)
	T2 = XT(1) * XT(1) * XT(2) * XT(2) 
	F = 60.D0 + T1 + (346.D0/T2) * (5.D0 + 346.D0/T1)
      RETURN
      END
C
C              SUBROUTINE FOR EXPLICIT CONSTRAINTS
      SUBROUTINE EXPCON(IFLG,ISKP,KKT,KOUNT,M,N,XMAX,XMIN,XT)
C
      INTEGER IFLG,ISKP,KKT,KOUNT,M,N
      DOUBLE PRECISION XMAX(2),XMIN(2),XT(2)
C

      IFLG=IFLG
      ISKP=ISKP
      N=N
      M=M
      XT(1)=XT(1)
      XT(2)=XT(2)
C               ABOVE TO STOP THE COMPILER FROM COMPLAINING  
C
 
      KKT=KKT+1
      KOUNT=KOUNT+1
      XMIN(1) = -99999.D0
      XMIN(2) = -99999.D0
      XMAX(1) =  99999.D0
      XMAX(2) =  99999.D0
      RETURN
      END
C
C
C             SUBROUTINE FOR IMPLICIT CONSTRAINTS
C
      SUBROUTINE IMPCON(KOUNT,M,N,NIC,XT,XX,XXMAX,XXMIN)
C
      INTEGER KOUNT,M,N,NIC
      DOUBLE PRECISION XX(1),XXMAX(1),XXMIN(1),XT(2)

      N=N
      NIC=NIC
C          TO STOP THE COMPILER FROM COMPLAINING
C
      KOUNT=KOUNT+1
      M=M+1
      XX(1) = XT(1) + XT(2)
      XXMAX(1) = 999999.D0
      XXMIN(1) = -999999.D0
      RETURN
      END
